VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmColorCount 
   Caption         =   "www.ActiveVB.de - Anzahl der Farben in einer Bitmap"
   ClientHeight    =   7485
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9690
   LinkTopic       =   "Form2"
   ScaleHeight     =   7485
   ScaleWidth      =   9690
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CD1 
      Left            =   2055
      Top             =   4695
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Dialog"
      Height          =   300
      Left            =   45
      TabIndex        =   7
      Top             =   315
      Width           =   1890
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   3075
      TabIndex        =   6
      Text            =   "12345"
      Top             =   300
      Width           =   945
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Testbild"
      Height          =   300
      Left            =   2010
      TabIndex        =   5
      Top             =   315
      Width           =   1000
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Methode 2"
      Height          =   300
      Left            =   5310
      TabIndex        =   3
      Top             =   315
      Width           =   1000
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Methode 1"
      Height          =   300
      Left            =   4245
      TabIndex        =   2
      Top             =   315
      Width           =   1000
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      Height          =   3900
      Left            =   1995
      ScaleHeight     =   3840
      ScaleWidth      =   5925
      TabIndex        =   1
      Top             =   660
      Width           =   5985
   End
   Begin VB.FileListBox File1 
      Height          =   6720
      Left            =   0
      TabIndex        =   0
      Top             =   645
      Width           =   1935
   End
   Begin VB.Line Line2 
      BorderColor     =   &H00FFFFFF&
      X1              =   4140
      X2              =   4140
      Y1              =   60
      Y2              =   600
   End
   Begin VB.Line Line1 
      X1              =   4125
      X2              =   4125
      Y1              =   60
      Y2              =   615
   End
   Begin VB.Label Label5 
      AutoSize        =   -1  'True
      Caption         =   "Auswahl"
      Height          =   195
      Left            =   705
      TabIndex        =   10
      Top             =   90
      Width           =   600
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Auswertung     Auswertung     Ergebnisse:"
      Height          =   195
      Left            =   4320
      TabIndex        =   9
      Top             =   90
      Width           =   2955
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Erzeuge       Anz. Farben"
      Height          =   195
      Left            =   2205
      TabIndex        =   8
      Top             =   75
      Width           =   1755
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Label1"
      Height          =   195
      Left            =   6450
      TabIndex        =   4
      Top             =   345
      Width           =   480
   End
End
Attribute VB_Name = "frmColorCount"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Anzahl der Farben einer Bitmap auslesen

' Autor/Copyright: K. Langbein, ActiveVB.de, Mrz 2008

' Gelegentlich kommt es vor, dass man die Anzahl der Farben
' in einer Bitmap, bzw. einem Bild bestimmen mu. Hier wird,
' gezeigt, wie man dies effizient und schnell tun kann. Es werden
' zwei einfache Methoden vorgestellt, die auf unterschiedlichen
' Systemen unterschiedlich schnell sind und unterschiedlich viel
' Speicherplatz bentigen.
'
' Anhand einer speziellen Funktion knnen Testbitmaps mit einer
' vorgegebenen Anzahl von Farben generiert werden, um die Algorithmen
' zu testen.

Option Explicit

Dim t As Single

Private Const DIB_RGB_COLORS = 0

Private Declare Function GetObject Lib "gdi32" Alias _
        "GetObjectA" (ByVal hObject As Long, ByVal nCount As _
        Long, lpObject As Any) As Long

' Deklaration fr bergabe vo BITMAPINFO256, welche Platz fr eine
' 256 Byte lange Farbpalette enthlt.
Private Declare Function GetDIBits256 Lib "gdi32" Alias "GetDIBits" ( _
        ByVal aHDC As Long, ByVal hBitmap As Long, _
        ByVal nStartScan As Long, ByVal nNumScans As Long, _
        lpBits As Any, lpBI As BITMAPINFO256, ByVal wUsage As Long) _
        As Long

         
Private Declare Function SetDIBits256 Lib "gdi32" Alias "SetDIBits" ( _
         ByVal hDc As Long, ByVal hBitmap As Long, _
         ByVal nStartScan As Long, ByVal nNumScans As Long, _
         lpBits As Any, lpBI As BITMAPINFO256, ByVal wUsage As Long) _
         As Long

Private Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type

Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

' Diese Sturktur enthlt gengend Platz um auch eine
' Farbpalette aufzunehmen. Man kann sie fr jede Art von
' Bitmap, also auch fr Bitmaps ohne Palette einsetzen.
Private Type BITMAPINFO256
  bmiHeader As BITMAPINFOHEADER
  bmiColors(255) As Long
End Type

Public Function ColorCount1(ByVal ReferenceDC As Long, _
                            ByVal Handle As Long) As Long

    Static Table() As Byte
    Dim HiBits As Long
    Dim LoBits As Long
    Dim Pixels() As Long
    Dim Col As Long
    Dim i As Long
    Dim j As Long
    Dim n As Long
    Dim cnt As Long
    Dim k As Long
    Dim Pow2(31) As Long
    Static IsInitiated As Boolean
    
    k = 2 ^ 24
    If IsInitiated = 0 Then
        ReDim Table(k) ' dann kostet die Dimensionierung Zeit
        IsInitiated = True
    Else
        ReDim Table(k) ' hier macht man zwar dasselbe, aber es
    End If             ' kostet keine Zeit. Man knnte auch
                       ' RtlZeromemory verwendeum um das Array zu
                       ' lerren. VB macht das jedoch auch mit Redim.

    n = GetBitmapData32(ReferenceDC, Handle, Pixels())
   
    If n <= 0 Then
        MsgBox "Cannot read data!"
        Exit Function
    End If
    
    t = Timer
    cnt = 0

    For i = 0 To UBound(Pixels)
    
       ' Wir schneiden das hchstwertige Byte ab, damit es
       ' keinen Index > 2^24 geben kann.
    
        Col = Pixels(i) And &HFFFFFF
        If Table(Col) = 0 Then
            cnt = cnt + 1
            Table(Col) = 1
            'Debug.Print Hex$(Col)
        End If
        
    Next i
    
    ColorCount1 = cnt

End Function

Public Function ColorCount2(ByVal ReferenceDC As Long, _
                            ByVal Handle As Long) As Long

    Dim Table() As Long
    Dim HiBits As Long
    Dim LoBits As Long
    Dim Pixels() As Long
    Dim Col As Long
    Dim i As Long
    Dim j As Long
    Dim n As Long
    Dim cnt As Long
    Dim k As Long
    Dim Pow2(31) As Long
    
    k = 2 ^ 19 '524288
    ReDim Table(k)
    
    For i = 0 To 30
        Pow2(i) = 2 ^ i
    Next i
    Pow2(31) = &H80000000 ' Hchstwertigstes Bit gesetzt
    

    n = GetBitmapData32(ReferenceDC, Handle, Pixels())
   
    If n <= 0 Then
        MsgBox "Cannot read data!"
        Exit Function
    End If
    
    t = Timer
    cnt = 0
    
    For i = 0 To UBound(Pixels)
    
        ' Wir schneiden das hchstwertige Byte ab, damit es
        ' keinen Index > 2^24 geben kann.
        
        Col = Pixels(i) And &HFFFFFF
        HiBits = Col \ 32   ' Die hherwertigen Bits ergeben den Index
        LoBits = Col And 31 ' Die unteren 4 Bit werden in der Tabelle
                            ' in Form von Zweierpotenzen eingetragen
                            
        If (Table(HiBits) And Pow2(LoBits)) = 0 Then
            cnt = cnt + 1
            Table(HiBits) = Table(HiBits) Or Pow2(LoBits)
        End If
        
    Next i
    
    ColorCount2 = cnt

End Function

Function GetBitmapData32(ByVal hDc As Long, _
                         ByVal Handle As Long, _
                         Data() As Long) As Long
    
    On Error GoTo err1
    
    Dim bmp As BITMAP
    Dim bInfo As BITMAPINFO256
    Dim nx As Long
    Dim ret As Long
    
    ret = GetObject(Handle, Len(bmp), bmp)
    If ret = 0 Then           ' Falls ein Fehler auftrat wird ret 0,
        GetBitmapData32 = -1  ' sonst ist es die Lnge der begebenen
        Exit Function         ' Struktur
    End If
     
    bInfo.bmiHeader.biHeight = bmp.bmHeight
    bInfo.bmiHeader.biWidth = bmp.bmWidth
    bInfo.bmiHeader.biPlanes = bmp.bmPlanes
    bInfo.bmiHeader.biBitCount = 32
    bInfo.bmiHeader.biSize = Len(bInfo.bmiHeader)
    bInfo.bmiHeader.biCompression = 0
    
    ' Der 1. Aufruf ohne bergabe von Data, dient zur Kontrolle. Wenn
    ' die Konversion funktioniert, wird unter W9x die Zahl der
    ' Bildzeilen zurckgegeben. Unter NT/XP wir ret <>0
    ret = GetDIBits256(hDc, Handle, 0, bmp.bmHeight, _
                                      ByVal 0, bInfo, DIB_RGB_COLORS)
    
    If ret = 0 Then           ' Falls ein Fehler auftrat wird ret 0
        GetBitmapData32 = -2
        Exit Function
    End If
                       
    ' Jetzt knnen wir die Breite einer Zeile berechnen. Im Fall
    ' der Konversion zu 32 Bit Farbtiefe entspricht die Zahl der
    ' bentigten Longs in x-Richtung der Breite des Bildes.
    nx = (bInfo.bmiHeader.biSizeImage / bInfo.bmiHeader.biHeight) / 4
    ReDim Data(nx * bmp.bmHeight - 1)
    
    ' Jetzt wird tatschlich gelesen. Die Bitmapdaten befinden sich
    ' anschlieend in Data().
    ret = GetDIBits256(hDc, Handle, 0, bmp.bmHeight, _
                                     Data(0), bInfo, DIB_RGB_COLORS)
                                     
    If ret = 0 Then         ' Falls ein Fehler auftrat wird ny = 0,
        GetBitmapData32 = -3
        ReDim Data(0, 0)
        Exit Function
    End If
                                     
'   Hier knnte man bereits das unbenutzte 4. Byte Null setzen.
'   Es ist jedoch gnstiger, dies in der Zhlroutine zu tun.
'   Wir schneiden das hchstwertigste Byte ab, damit es
'   keinen berlauf gibt:
'    For i = 0 To UBound(Data)
'        Data(i) = Data(i) And &HFFFFFF
'    Next
                        
                        
    GetBitmapData32 = UBound(Data)
    Exit Function
    
err1:
    Select Case Err
    
    Case 999
    
    Case Else
        MsgBox "Fehler in GetBitmapData32:" & vbCrLf & vbCrLf _
                & Err & ": " & Error$
        'Resume
    End Select
    
End Function

Function SetBitmapData32(ByVal hDc As Long, _
                         ByVal Handle As Long, _
                         Data() As Long) As Long
    
    On Error GoTo err1
    
    Dim bmp As BITMAP
    Dim bInfo As BITMAPINFO256
    Dim nx As Long
    Dim ret As Long

    ret = GetObject(Handle, Len(bmp), bmp)
    If ret = 0 Then           ' Falls ein Fehler auftrat wird ret 0,
        SetBitmapData32 = -1  ' sonst ist es die Lnge der begebenen
        Exit Function         ' Struktur
    End If
     
    bInfo.bmiHeader.biHeight = bmp.bmHeight
    bInfo.bmiHeader.biWidth = bmp.bmWidth
    bInfo.bmiHeader.biPlanes = bmp.bmPlanes
    bInfo.bmiHeader.biBitCount = 32
    bInfo.bmiHeader.biSize = Len(bInfo.bmiHeader)
    bInfo.bmiHeader.biCompression = 0
    
    ' Der 1. Aufruf ohne bergabe von Data, dient zur Kontrolle. Wenn
    ' die Konversion funktioniert, wird unter W9x die Zahl der
    ' Bildzeilen zurckgegeben. Unter NT/XP wir ret <>0
    ret = GetDIBits256(hDc, Handle, 0, bmp.bmHeight, _
                                      ByVal 0, bInfo, DIB_RGB_COLORS)
    
    If ret = 0 Then         ' Falls ein Fehler auftrat wird nLines 0,
        SetBitmapData32 = -2 ' sonst ist es die Zahl der Zeilen.
        Exit Function
    End If
                       
      
    ' Jetzt die Daten in die Bitmap bertragen und von 32 Bit in
    ' die eingestellte Farbtiefe umgerechnet.
    ret = SetDIBits256(hDc, Handle, 0, bmp.bmHeight, _
                                      Data(0), bInfo, DIB_RGB_COLORS)
                                     
    If ret = 0 Then         ' Falls ein Fehler auftrat wird ny = 0,
        SetBitmapData32 = -3
        Exit Function
    End If
                                     
                        
    SetBitmapData32 = UBound(Data)
    
    Exit Function
    
err1:
    Select Case Err
    
    Case 999
    
    Case Else
        MsgBox "Fehler in SetBitmapData32:" & vbCrLf & vbCrLf _
                & Err & ": " & Error$
        'Resume
    End Select
    
End Function


Private Sub Command1_Click()

    Dim n As Long
    Dim Handle As Long
    Handle = Picture1.Picture
    If Handle = 0 Then
        Handle = Picture1.Image
    End If
    
    n = ColorCount1(Picture1.hDc, Handle)
    Label1.Caption = "Anzahl der Farben: " & n _
                      & "   Zeit: " & Format$(Timer - t, "0.0000")

End Sub

Private Sub Command2_Click()

    Dim n As Long
    Dim Handle As Long
    
    Handle = Picture1.Picture
    If Handle = 0 Then
        Handle = Picture1.Image
    End If
    n = ColorCount2(Picture1.hDc, Handle)
    Label1.Caption = "Anzahl der Farben: " & n _
                      & "   Zeit: " & Format$(Timer - t, "0.0000")

    
End Sub


Private Sub Command3_Click()

    Dim Table() As Byte
    Dim nColors As Long
    Dim Col() As Long
    Dim i As Long
    Dim j As Long
    Dim Data() As Long
    Dim n As Long
    Dim nPix As Long
    Dim ok As Long
    Dim c As Long
    
    Picture1.ScaleMode = 3
    Picture1.AutoRedraw = True
    nPix = Picture1.ScaleHeight * Picture1.ScaleWidth
    
    nColors = 2 ^ 24 - 1
    ReDim Table(nColors)
    Table(0) = 1
    
    n = Val(Text1.Text)
    If n > nPix Then
        n = nPix
        Text1.Text = nPix
    End If
    ReDim Col(n)
    
    Randomize Timer
    For i = 1 To n
        Do
            ok = 0
            c = CLng(Rnd * nColors)
            If Table(c) = 0 Then
                Table(c) = 1
                j = j + 1
                Col(j) = c
                ok = 1
            Else
                'Beep
            End If
        Loop Until ok = 1
    Next i
    
    ReDim Data(nPix)
    j = 1
    For i = 0 To nPix
        Data(i) = Col(j)
        j = j + 1
        If j > UBound(Col) Then
            j = 1
        End If
    Next i
    
exi:

    Picture1.Cls
    Set Picture1.Picture = Nothing
    ok = SetBitmapData32(Picture1.hDc, Picture1.Image, Data())
    'Picture1.Picture = Picture1.Image ' kann man, mu man aber nicht
    Picture1.Refresh
    Label1.Caption = "Anzahl der Farben: ?         " _
                      & "   Zeit: ?"

End Sub

Private Sub Command4_Click()

    Dim Fn$
    Dim Pos As Long
    Dim i As Long
    
    CD1.ShowOpen
    Fn$ = CD1.FileName
    Pos = InStrRev(CD1.FileName, "\")
    If Pos > 0 Then
        Fn$ = Left$(Fn$, Pos - 1)
        File1.Path = Fn$
    End If
    Fn$ = CD1.FileTitle
    If Fn$ <> "" Then
        For i = 0 To File1.ListCount
            If Fn$ = File1.List(i) Then
                File1.ListIndex = i
                Exit For
            End If
        Next i
    End If
    
End Sub

Private Sub File1_Click()
    
    Dim Fn$
    Fn$ = File1.Path & "\" & File1.List(File1.ListIndex)
    Fn$ = Replace(Fn$, "\\", "\")
    Picture1.Picture = LoadPicture(Fn$)
    Label1.Caption = "Anzahl der Farben: ?        Zeit: ?"
    
    
End Sub

Private Sub Form_Load()

    Picture1.AutoSize = True
    Picture1.Picture = Picture1.Image
    File1.Pattern = "*.bmp;*.gif;*.jpeg;*.jpg"
    File1.Path = App.Path ' Hier ggf. Ordner mit Bildern eintragen
    
    If File1.ListCount > 0 Then
         File1.ListIndex = 0
    End If
    
    Label1.Caption = "Anzahl der Farben: ?        Zeit: ?"
    Command1.Caption = "Methode 1"
    Command2.Caption = "Methode 2"
    Command3.Caption = "Testbild"
    Command4.Caption = "Dialog"
    Text1.Text = "12345"
    
End Sub

Private Sub Form_Resize()

    If Me.WindowState <> 1 Then
        File1.Height = Me.Height - File1.Top - 400
    End If
    
End Sub
